# autogenerated by ssc-gen DO NOT_EDIT
from __future__ import annotations
from typing import TypedDict, Union, Optional
from contextlib import suppress
import sys

if sys.version_info >= (3, 10):
    from types import NoneType
else:
    NoneType = type(None)

from parsel import Selector
from parsel.selector import _SelectorType  # noqa

T_Main = TypedDict(
    "T_Main",
    {
        "title_ok": str,
        "title_null": Optional[str],
        "title_str_default": str,
        "title_int_default": int,
        "title_float_default": float,
    },
)


class Main:
    """default value set example, if field code parse throw exception

    USAGE:
        - pass index.html document from 3_default_values folder


    {
        "title_ok": "String",
        "title_null": "String",
        "title_str_default": "String",
        "title_int_default": "Int",
        "title_float_default": "Float"
    }"""

    def __init__(self, document: Union[str, _SelectorType]) -> None:
        self._doc = (
            Selector(document) if isinstance(document, str) else document
        )

    def _parse_title_ok(self, value: Selector) -> str:
        value1 = value.css("title")
        return "".join(value1.css("::text").getall())

    def _parse_title_null(self, value: Selector) -> Optional[str]:
        value1 = value
        with suppress(Exception):
            value2 = value1.css("title")
            assert value2.css("a"), ""
            value3 = value2
            return "".join(value3.css("::text").getall())
        return None

    def _parse_title_str_default(self, value: Selector) -> str:
        value1 = value
        with suppress(Exception):
            value2 = value1.css("title")
            assert value2.css("a"), ""
            value3 = value2
            return "".join(value3.css("::text").getall())
        return "unknown"

    def _parse_title_int_default(self, value: Selector) -> int:
        value1 = value
        with suppress(Exception):
            value2 = value1.css("title")
            value3 = "".join(value2.css("::text").getall())
            return int(value3)
        return 1

    def _parse_title_float_default(self, value: Selector) -> float:
        value1 = value
        with suppress(Exception):
            value2 = value1.css("title")
            value3 = "".join(value2.css("::text").getall())
            return float(value3)
        return 3.14

    def parse(self) -> T_Main:
        return {
            "title_ok": self._parse_title_ok(self._doc),
            "title_null": self._parse_title_null(self._doc),
            "title_str_default": self._parse_title_str_default(self._doc),
            "title_int_default": self._parse_title_int_default(self._doc),
            "title_float_default": self._parse_title_float_default(self._doc),
        }
